<?php

/*
* fivestar module support
* NOTE: if you're wondering why this file is called
* 'votingapi_field_vf_fivestar.inc' it is because in order to implement
* the AJAX callback, hook_menu must be implemented. If the name was
* 'votingapi_field_fivestar.inc', the hook would need to be called
* 'fivestar_menu', which is already taken.
*/

/**
 * Implements hook_menu().
 */
function fivestar_votingapi_field_extra_menu($may_cache) {
  $items = array();
  if (!$may_cache) {
    $items[] = array(
      'type' => MENU_CALLBACK,
      'path' => 'votingapi_field/fivestar',
      'access' => user_access('register vote'),
      'callback' => '_vf_fivestar_vote'
    );
  }
  return $items;
}

/**
 * Implements hook_votingapi_field_form_generators().
 */
function fivestar_votingapi_field_form_generators() {
  $form_infos = array();
  if (module_exists('fivestar')) {
    $form_infos[] = array(
      'name' => t('Fivestar Module'),
      'generator' => 'vf_fivestar_score',
      'js' => false,
      'types' => array('votingapi_score')
    );
  }
  return $form_infos;
}

function vf_fivestar_score($node, $field) {
  // double check here in case someone disabled the mod.
  if (!module_exists('fivestar'))
    return vf_fivestar_std_score($node, $field);

  fivestar_widget_form($node); // fancy css and js widget
  $form = fivestar_form($content_type, $content_id);
  $form['vote']['#auto-submit'] = false;

  $uservotes = votingapi_get_user_votes('points', $nid);
  if (count($uservotes)) {
    drupal_set_message('user votes: ' . serialize($uservotes));
	$score = 0; //!!!
  }
  else $score = '';
  $url = 'votingapi_field/fivestar/';
  $url .= $field['field_name'];
  $url .= "/$node->nid/$score";
  drupal_set_message('auto_submit_path: ' . $url);
  $form['vote']['#auto_submit_path'] = "$url";
  return $form;
}

function vf_fivestar_score_submit($form_id, $edit) {
  votingapi_field_submit_vote($form_id, $edit, 'score');
}

function _vf_fivestar_vote($field_name, $nid, $vote) {
  $field = content_fields($field_name);
  $node = node_load(array('nid'=>$nid));
  node_view($node);
  switch($field['type']) {
    case 'votingapi_score': $votealgo = 'points'; break;
    case 'votingapi_choice': $votealgo = 'option'; break;
    case 'votingapi_percent': $votealgo = 'percent'; break;
    case 'votingapi_rating': $votealgo = 'points'; break;
    default: $votealgo = 'points';
  }
  $err = votingapi_field_vote($field, $node, $vote, $votealgo);
  if ($err !== true) {
    print $err;
    return;
  }
  $uservotes = votingapi_get_user_votes($votetype, $node->nid);
  if (count($uservotes)) {
    $output = '';
    $output .= '<?xml version="1.0" encoding="UTF-8"?>';
    $output .= '<result>';
    foreach ($uservotes as $data) {
      $output .= '<'. $data->function .'>' . $data->value . '</'. $data->function .'>';
    }
    $output .= '</result>';
    $output .= '<vote>';
    $output .= '<value>' . $vote . '</value>';
    $output .= '<type>' . $field_name . '</type>';
    $output .= '<id>' . $node->nid. '</id>';
    $output .= '</vote>';
  }
  else {
    $output = 'false';
  }
  exit($output);  
}

